//*****************************************************************
// 
//  JAVA Source for com.idautomation.pdf417; 4.10
//  
//  Copyright, IDAutomation.com, Inc. 2000-2004. 
//  All rights reserved.
//  
//  http://www.IDAutomation.com/java/
//  
//  NOTICE:
//  You may incorporate our Source Code in your application
//  only if you own a valid Java Developer License
//  from IDAutomation.com, Inc. and the copyright notices 
//  are not removed from the source code.
//  
//*****************************************************************


package com.idautomation.pdf417;

import java.awt.*;
import java.applet.*;

/** This is the PDF417 applet that creates a barcode from the PDF417 class. */

public class PDF417Applet extends Applet
{

        // ** updated for servlet operation 5/31/2001
	public PDF417 BC=null;
        public boolean isStandalone=false;
        // ** end of update

	public PDF417Applet() {
		this.setLayout(new java.awt.BorderLayout());
	}

	public void start() {
		BC.paint(this.getGraphics());
		BC.autoSize=false;
	}

	public void refresh() {
                BC.paint(BC.getGraphics());
		this.paintAll(this.getGraphics());
	}

	public void init() {
		// create bar code PDF417
		if (BC==null) BC=new PDF417();	
		
		this.add("Center",BC);		

		initParam("N");
		initParam("X");
		initParam("I");
		initParam("H");
		initParam("BAR_HEIGHT");
		initParam("BAR_COLOR");
		initParam("FONT_COLOR");
		initParam("TEXT_FONT");
		initParam("BACK_COLOR");
		initParam("LEFT_MARGIN");
		initParam("TOP_MARGIN");
		initParam("BARCODE");
		initParam("ROTATE");

		// pdf417 specific
        initParam("PT");
		initParam("XYR");
		initParam("TRN");
		initParam("MODE");
		initParam("ROWS");
		initParam("COL");
		initParam("ECL");

	}

	private void initParam(String p) {
		String v=getStringParam(p,"");
		if (v.length()==0) return;
	    setParameter(p,v);
	}

	public void setParameter(String p,String v) {

            if (v==null) return;

		if (p.compareTo("N")==0) BC.N=new Double(v).doubleValue();
		
		if (p.compareTo("ROTATE")==0) BC.rotate=(int) (new Double(v).doubleValue());
		
		if (p.compareTo("X")==0) BC.setXDimensionCM((double) (new Double(v).doubleValue()));

		if (p.compareTo("XYR")==0) BC.setXtoYRatio((double) (new Double(v).doubleValue()));

		if (p.compareTo("TRN")==0) BC.truncated=(v.compareTo("Y")==0);

		if (p.compareTo("I")==0) BC.I=new Double(v).doubleValue();

		if (p.compareTo("LEFT_MARGIN")==0) BC.leftMarginCM=new Double(v).doubleValue();

		if (p.compareTo("TOP_MARGIN")==0) BC.topMarginCM=new Double(v).doubleValue();

		if (p.compareTo("BAR_COLOR")==0) BC.barColor=convertColor(v);

		if (p.compareTo("FONT_COLOR")==0) BC.fontColor=convertColor(v);

		if (p.compareTo("BACK_COLOR")==0) BC.backColor=convertColor(v);

		if (p.compareTo("TEXT_FONT")==0) BC.textFont=convertFont(v);

		if (p.compareTo("H")==0) BC.H=new Double(v).doubleValue();

		if (p.compareTo("PT")==0) BC.processTilde=(v.toUpperCase().compareTo("Y")==0);

//		if (p.compareTo("BARCODE")==0) BC.code=v;

		if (p.compareTo("BARCODE")==0) BC.setDataToEncode(v);

		if (p.compareTo("ROWS")==0) BC.PDFRows=new Integer(v).intValue();
		if (p.compareTo("COL")==0) BC.PDFColumns=new Integer(v).intValue();
		if (p.compareTo("ECL")==0) BC.PDFECLevel=new Integer(v).intValue();
		
		if (p.compareTo("MODE")==0) {
			if (v.compareTo("BINARY")==0) BC.PDFMode=BC.PDF_BINARY;
			//if (v.compareTo("NUMERIC")==0) BC.PDFMode=BC.PDF_NUMERIC;
			if (v.compareTo("TEXT")==0) BC.PDFMode=BC.PDF_TEXT;
		}
	}

  // function to convert a String parameter to a color
  public java.awt.Color convertColor(String c) {
	if (c.compareTo("NULL")==0) return null;
    if (c.compareTo("RED")==0) return java.awt.Color.red;
    if (c.compareTo("BLACK")==0) return java.awt.Color.black;
    if (c.compareTo("BLUE")==0) return java.awt.Color.blue;
    if (c.compareTo("CYAN")==0) return java.awt.Color.cyan;
    if (c.compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
    if (c.compareTo("GRAY")==0) return java.awt.Color.gray;
    if (c.compareTo("GREEN")==0) return java.awt.Color.green;
    if (c.compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
    if (c.compareTo("MAGENTA")==0) return java.awt.Color.magenta;
    if (c.compareTo("ORANGE")==0) return java.awt.Color.orange;
    if (c.compareTo("PINK")==0) return java.awt.Color.pink;
    if (c.compareTo("WHITE")==0) return java.awt.Color.white;
    if (c.compareTo("YELLOW")==0) return java.awt.Color.yellow;
    try {
       return java.awt.Color.decode(c);
    } catch (Exception e) {return java.awt.Color.black;}
  }

  // convert an applet parameter to a Font
  public java.awt.Font convertFont(String f) {

    String[] items=convertList(f);

   if (items==null) return null;

    if (items.length<3) return null;

    int s=java.awt.Font.PLAIN;
    if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
    if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

    try {
    return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
    }
    catch (Exception e) {return null;}

  }

  // ** updated for servlet operation 5/31/2001
  // get a parameter as string
  protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);


    }


  //Get a parameter value
  private String getParameter(String key, String def) {


    if (isStandalone) return def;

    if (this.getParameter(key) != null) return this.getParameter(key) ;
    else return def;
  }

  private String[] convertList(String items){

   String[] itema=new String[500];
   int itemCount=0;

   // count number of items
   int p=items.indexOf("|");
   while (p>=0) {
      itema[itemCount++]=items.substring(0,p);
      items=items.substring(p+1,items.length());
      p=items.indexOf("|");
   }

   if (items.compareTo("")!=0) itema[itemCount++]=items;

   if (itemCount==0) return null;

   String[] result=new String[itemCount];
   for (int i=0;i<itemCount;i++) result[i]=itema[i];

   return result;

 }

  private Integer getIntParam(String Param,Integer def) {

    try {
      String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
      return new Integer(s);
    }
    catch(Exception e) {
      return def;
    }
   }

   private Double getDoubleParam(String Param,Double def) {

      try {
       String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
     return new Double(s);
    }
    catch(Exception e) {
      return def;
    }
    }
    // ** end of update

}
